/**
 * <copyright>
 * </copyright>
 *
 * $Id: CoreFactory.java 9011 2012-01-13 14:48:10Z mjohannes $
 */
package org.openxma.dsl.core;

import org.eclipse.emf.ecore.EFactory;
import org.openxma.dsl.core.model.AdditiveExpr;
import org.openxma.dsl.core.model.AdditiveRights;
import org.openxma.dsl.core.model.AtomicBoolExpr;
import org.openxma.dsl.core.model.AtomicExpr;
import org.openxma.dsl.core.model.BooleanParameterValue;
import org.openxma.dsl.core.model.Call;
import org.openxma.dsl.core.model.CondANDExpr;
import org.openxma.dsl.core.model.CondANDRights;
import org.openxma.dsl.core.model.CondORExpr;
import org.openxma.dsl.core.model.CondORRights;
import org.openxma.dsl.core.model.ConditionsBlock;
import org.openxma.dsl.core.model.Constraint;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.Editor;
import org.openxma.dsl.core.model.EnumLiteral;
import org.openxma.dsl.core.model.EnumType;
import org.openxma.dsl.core.model.EqualityExpr;
import org.openxma.dsl.core.model.FalseLiteral;
import org.openxma.dsl.core.model.Function;
import org.openxma.dsl.core.model.IDocumentable;
import org.openxma.dsl.core.model.Import;
import org.openxma.dsl.core.model.Incrementer;
import org.openxma.dsl.core.model.IncrementerReference;
import org.openxma.dsl.core.model.IntLiteral;
import org.openxma.dsl.core.model.IntegerParameterValue;
import org.openxma.dsl.core.model.Literal;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.core.model.MultiplicativeExpr;
import org.openxma.dsl.core.model.MultiplicativeRights;
import org.openxma.dsl.core.model.ParameterDefinition;
import org.openxma.dsl.core.model.ParameterValue;
import org.openxma.dsl.core.model.ParenExpr;
import org.openxma.dsl.core.model.ReferenceWithParameter;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.core.model.RelationalExpr;
import org.openxma.dsl.core.model.SimpleType;
import org.openxma.dsl.core.model.SqlType;
import org.openxma.dsl.core.model.StatusFlag;
import org.openxma.dsl.core.model.StringLiteral;
import org.openxma.dsl.core.model.StringParameterValue;
import org.openxma.dsl.core.model.Style;
import org.openxma.dsl.core.model.TrueLiteral;
import org.openxma.dsl.core.model.Type;
import org.openxma.dsl.core.model.TypeDefinition;
import org.openxma.dsl.core.model.Validator;
import org.openxma.dsl.core.model.ValidatorReference;
import org.openxma.dsl.core.model.Variable;
import org.openxma.dsl.core.model.XmadslVariable;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.core.CorePackage
 * @generated
 */
public interface CoreFactory extends EFactory {
	/**
     * The singleton instance of the factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	CoreFactory eINSTANCE = org.openxma.dsl.core.model.impl.CoreFactoryImpl.init();

	/**
     * Returns a new object of class '<em>Model</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Model</em>'.
     * @generated
     */
	Model createModel();

	/**
     * Returns a new object of class '<em>Import</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Import</em>'.
     * @generated
     */
	Import createImport();

	/**
     * Returns a new object of class '<em>Type</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Type</em>'.
     * @generated
     */
	Type createType();

	/**
     * Returns a new object of class '<em>Simple Type</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Simple Type</em>'.
     * @generated
     */
	SimpleType createSimpleType();

	/**
     * Returns a new object of class '<em>Sql Type</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Sql Type</em>'.
     * @generated
     */
	SqlType createSqlType();

	/**
     * Returns a new object of class '<em>Enum Type</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Enum Type</em>'.
     * @generated
     */
	EnumType createEnumType();

	/**
     * Returns a new object of class '<em>Enum Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Enum Literal</em>'.
     * @generated
     */
	EnumLiteral createEnumLiteral();

	/**
     * Returns a new object of class '<em>Parameter Definition</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Parameter Definition</em>'.
     * @generated
     */
	ParameterDefinition createParameterDefinition();

	/**
     * Returns a new object of class '<em>Reference With Parameter</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Reference With Parameter</em>'.
     * @generated
     */
	ReferenceWithParameter createReferenceWithParameter();

	/**
     * Returns a new object of class '<em>Validator Reference</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Validator Reference</em>'.
     * @generated
     */
	ValidatorReference createValidatorReference();

	/**
     * Returns a new object of class '<em>Validator</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Validator</em>'.
     * @generated
     */
	Validator createValidator();

	/**
     * Returns a new object of class '<em>Incrementer</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Incrementer</em>'.
     * @generated
     */
	Incrementer createIncrementer();

	/**
     * Returns a new object of class '<em>Incrementer Reference</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Incrementer Reference</em>'.
     * @generated
     */
	IncrementerReference createIncrementerReference();

	/**
     * Returns a new object of class '<em>Editor</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Editor</em>'.
     * @generated
     */
	Editor createEditor();

	/**
     * Returns a new object of class '<em>Style</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Style</em>'.
     * @generated
     */
	Style createStyle();

	/**
     * Returns a new object of class '<em>Type Definition</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Type Definition</em>'.
     * @generated
     */
	TypeDefinition createTypeDefinition();

	/**
     * Returns a new object of class '<em>Data Type And Type Parameter</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Data Type And Type Parameter</em>'.
     * @generated
     */
	DataTypeAndTypeParameter createDataTypeAndTypeParameter();

	/**
     * Returns a new object of class '<em>Parameter Value</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Parameter Value</em>'.
     * @generated
     */
	ParameterValue createParameterValue();

	/**
     * Returns a new object of class '<em>Integer Parameter Value</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Integer Parameter Value</em>'.
     * @generated
     */
	IntegerParameterValue createIntegerParameterValue();

	/**
     * Returns a new object of class '<em>String Parameter Value</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>String Parameter Value</em>'.
     * @generated
     */
	StringParameterValue createStringParameterValue();

	/**
     * Returns a new object of class '<em>Boolean Parameter Value</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Boolean Parameter Value</em>'.
     * @generated
     */
	BooleanParameterValue createBooleanParameterValue();

	/**
     * Returns a new object of class '<em>Conditions Block</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Conditions Block</em>'.
     * @generated
     */
	ConditionsBlock createConditionsBlock();

	/**
     * Returns a new object of class '<em>Constraint</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Constraint</em>'.
     * @generated
     */
	Constraint createConstraint();

	/**
     * Returns a new object of class '<em>Equality Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Equality Expr</em>'.
     * @generated
     */
	EqualityExpr createEqualityExpr();

	/**
     * Returns a new object of class '<em>Cond OR Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Cond OR Expr</em>'.
     * @generated
     */
	CondORExpr createCondORExpr();

	/**
     * Returns a new object of class '<em>Cond OR Rights</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Cond OR Rights</em>'.
     * @generated
     */
	CondORRights createCondORRights();

	/**
     * Returns a new object of class '<em>Cond AND Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Cond AND Expr</em>'.
     * @generated
     */
	CondANDExpr createCondANDExpr();

	/**
     * Returns a new object of class '<em>Cond AND Rights</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Cond AND Rights</em>'.
     * @generated
     */
	CondANDRights createCondANDRights();

	/**
     * Returns a new object of class '<em>Atomic Bool Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Atomic Bool Expr</em>'.
     * @generated
     */
	AtomicBoolExpr createAtomicBoolExpr();

	/**
     * Returns a new object of class '<em>Relational Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Relational Expr</em>'.
     * @generated
     */
	RelationalExpr createRelationalExpr();

	/**
     * Returns a new object of class '<em>Additive Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Additive Expr</em>'.
     * @generated
     */
	AdditiveExpr createAdditiveExpr();

	/**
     * Returns a new object of class '<em>Additive Rights</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Additive Rights</em>'.
     * @generated
     */
	AdditiveRights createAdditiveRights();

	/**
     * Returns a new object of class '<em>Multiplicative Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Multiplicative Expr</em>'.
     * @generated
     */
	MultiplicativeExpr createMultiplicativeExpr();

	/**
     * Returns a new object of class '<em>Multiplicative Rights</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Multiplicative Rights</em>'.
     * @generated
     */
	MultiplicativeRights createMultiplicativeRights();

	/**
     * Returns a new object of class '<em>Atomic Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Atomic Expr</em>'.
     * @generated
     */
	AtomicExpr createAtomicExpr();

	/**
     * Returns a new object of class '<em>Variable</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Variable</em>'.
     * @generated
     */
	Variable createVariable();

	/**
     * Returns a new object of class '<em>Xmadsl Variable</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Xmadsl Variable</em>'.
     * @generated
     */
	XmadslVariable createXmadslVariable();

	/**
     * Returns a new object of class '<em>Referenceable By Xmadsl Variable</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Referenceable By Xmadsl Variable</em>'.
     * @generated
     */
	ReferenceableByXmadslVariable createReferenceableByXmadslVariable();

	/**
     * Returns a new object of class '<em>Status Flag</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Status Flag</em>'.
     * @generated
     */
	StatusFlag createStatusFlag();

	/**
     * Returns a new object of class '<em>Call</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Call</em>'.
     * @generated
     */
	Call createCall();

	/**
     * Returns a new object of class '<em>Function</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Function</em>'.
     * @generated
     */
	Function createFunction();

	/**
     * Returns a new object of class '<em>Paren Expr</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Paren Expr</em>'.
     * @generated
     */
	ParenExpr createParenExpr();

	/**
     * Returns a new object of class '<em>Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Literal</em>'.
     * @generated
     */
	Literal createLiteral();

	/**
     * Returns a new object of class '<em>Int Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Int Literal</em>'.
     * @generated
     */
	IntLiteral createIntLiteral();

	/**
     * Returns a new object of class '<em>String Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>String Literal</em>'.
     * @generated
     */
	StringLiteral createStringLiteral();

	/**
     * Returns a new object of class '<em>True Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>True Literal</em>'.
     * @generated
     */
	TrueLiteral createTrueLiteral();

	/**
     * Returns a new object of class '<em>False Literal</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>False Literal</em>'.
     * @generated
     */
	FalseLiteral createFalseLiteral();

	/**
     * Returns the package supported by this factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the package supported by this factory.
     * @generated
     */
	CorePackage getCorePackage();

    /**
     * @generated NOT
     */
    SimpleType createSimpleType(String name, String instanceType);

} //CoreFactory
